# PINRemoteImageManager Class Reference

Inherits from | NSObject
Declared in | PINRemoteImageManager.h

## Overview

PINRemoteImageManager is the main workhorse of PINRemoteImage. It is unnecessary to access directly if you simply wish to download images and have them rendered in a UIImageView, UIButton or FLAnimatedImageView.

However, if you wish to download images directly, this class is your guy / gal.

You can use this class to download images, postprocess downloaded images, prefetch images, download images progressively, or download one image in a set of images depending on network performance.

### `+ sharedImageManager`

Get the shared instance of PINRemoteImageManager

`+ (instancetype)sharedImageManager`

#### Return Value

Shared instance of PINRemoteImageManager

#### Declared In

`PINRemoteImageManager.h`

### `– defaultImageCache`

The result of this method is assigned to self.cache in init. If you wish to provide a customized cache to the manager you can subclass PINRemoteImageManager and return a custom PINCache from this method.

`- (PINCache *)defaultImageCache`

#### Return Value

An instance of a PINCache object.

#### Declared In

`PINRemoteImageManager.h`

### `– setHighQualityBPSThreshold:completion:`

Set the minimum BPS to download the highest quality image in a set.

`- (void)setHighQualityBPSThreshold:(float)highQualityBPSThreshold completion:(dispatch_block_t)completion`

#### Parameters

`highQualityBPSThreshold` | bytes per second minimum. Defaults to 500000.
`completion` | Completion to be called once highQualityBPSThreshold has been set.

#### See Also

- `

  - downloadImageWithURLs:options:progress:completion:

  `

#### Declared In

`PINRemoteImageManager.h`

### `– setLowQualityBPSThreshold:completion:`

Set the maximum BPS to download the lowest quality image in a set.

`- (void)setLowQualityBPSThreshold:(float)lowQualityBPSThreshold completion:(dispatch_block_t)completion`

#### Parameters

`lowQualityBPSThreshold` | bytes per second maximum. Defaults to 50000.
`completion` | Completion to be called once lowQualityBPSThreshold has been set.

#### See Also

- `

  - downloadImageWithURLs:options:progress:completion:

  `

#### Declared In

`PINRemoteImageManager.h`

### `– setShouldUpgradeLowQualityImages:completion:`

Set whether high quality images should be downloaded when a low quality image is cached if network connectivity has improved.

`- (void)setShouldUpgradeLowQualityImages:(BOOL)shouldUpgradeLowQualityImages completion:(dispatch_block_t)completion`

#### Parameters

`shouldUpgradeLowQualityImages` | if YES, low quality images will be ‘upgraded’.
`completion` | Completion to be called once shouldUpgradeLowQualityImages has been set.

#### See Also

- `

  - downloadImageWithURLs:options:progress:completion:

  `

#### Declared In

`PINRemoteImageManager.h`

### `– setMaxNumberOfConcurrentOperations:completion:`

Set the maximum number of concurrent operations (decompressing images, creating gifs, etc).

`- (void)setMaxNumberOfConcurrentOperations:(NSInteger)maxNumberOfConcurrentOperations completion:(dispatch_block_t)completion`

#### Parameters

`maxNumberOfConcurrentOperations` | The maximum number of concurrent operations. Defaults to NSOperationQueueDefaultMaxConcurrentOperationCount.
`completion` | Completion to be called once maxNumberOfConcurrentOperations is set.

#### Declared In

`PINRemoteImageManager.h`

### `– setMaxNumberOfConcurrentDownloads:completion:`

Set the maximum number of concurrent downloads.

`- (void)setMaxNumberOfConcurrentDownloads:(NSInteger)maxNumberOfConcurrentDownloads completion:(dispatch_block_t)completion`

#### Parameters

`maxNumberOfConcurrentDownloads` | The maximum number of concurrent downloads. Defaults to 10.
`completion` | Completion to be called once maxNumberOfConcurrentDownloads is set.

#### Declared In

`PINRemoteImageManager.h`

### `– setEstimatedRemainingTimeThresholdForProgressiveDownloads:completion:`

Set the estimated time remaining to download threshold at which to generate progressive images. Progressive images previews will only be generated if the estimated remaining time on a download is greater than estimatedTimeRemainingThreshold. If estimatedTimeRemainingThreshold is less than zero, this check is skipped.

`- (void)setEstimatedRemainingTimeThresholdForProgressiveDownloads:(NSTimeInterval)estimatedRemainingTimeThreshold completion:(dispatch_block_t)completion`

#### Parameters

`estimatedRemainingTimeThreshold` | The estimated remaining time threshold used to decide to skip progressive rendering. Defaults to 0.1.
`completion` | Completion to be called once estimatedTimeRemainingTimeThreshold is set.

#### Declared In

`PINRemoteImageManager.h`

### `– setProgressThresholds:completion:`

Sets the progress at which progressive images are generated. By default this is @[@0.00, @0.35, @0.65] which generates at most, 3 progressive images. The first progressive image will only be generated when at least one scan has been completed (so you never see half an image).

`- (void)setProgressThresholds:(NSArray *)progressThresholds completion:(dispatch_block_t)completion`

#### Parameters

`progressThresholds` | an array of progress thresholds at which to generate progressive images. progress thresholds should range from 0.00 - 1.00. Defaults to @[@0.00, @0.35, @0.65]
`completion` | Completion to be called once progressThresholds is set.

#### Declared In

`PINRemoteImageManager.h`

### `– prefetchImageWithURL:`

Prefetch an image at the given URL.

`- (void)prefetchImageWithURL:(NSURL *)url`

#### Parameters

`url` | NSURL where the image to prefetch resides.

#### Declared In

`PINRemoteImageManager.h`

### `– prefetchImageWithURL:options:`

Prefetch an image at the given URL with given options.

`- (void)prefetchImageWithURL:(NSURL *)url options:(PINRemoteImageManagerDownloadOptions)options`

#### Parameters

`url` | NSURL where the image to prefetch resides.
`options` | PINRemoteImageManagerDownloadOptions options with which to pefetch the image.

#### Declared In

`PINRemoteImageManager.h`

### `– prefetchImagesWithURLs:`

Prefetch images at the given URLs.

`- (void)prefetchImagesWithURLs:(NSArray *)urls`

#### Parameters

`urls` | An array of NSURLs where the images to prefetch reside.

#### Declared In

`PINRemoteImageManager.h`

### `– prefetchImagesWithURLs:options:`

Prefetch images at the given URLs with given options.

`- (void)prefetchImagesWithURLs:(NSArray *)urls options:(PINRemoteImageManagerDownloadOptions)options`

#### Parameters

`urls` | An array of NSURLs where the images to prefetch reside.
`options` | PINRemoteImageManagerDownloadOptions options with which to pefetch the image.

#### Declared In

`PINRemoteImageManager.h`

### `– downloadImageWithURL:completion:`

Download or retrieve from cache the image found at the url. All completions are called on an arbitrary callback queue unless called on the main thread and the result is in the memory cache (this is an optimization to allow synchronous results for the UI when an object is cached in memory).

`- (NSUUID *)downloadImageWithURL:(NSURL *)url completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`url` | NSURL where the image to download resides.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache or downloaded.

#### Return Value

An NSUUID which uniquely identifies this request. To be used for canceling requests and verifying that the callback is for the request you expect (see categories for example).

#### Declared In

`PINRemoteImageManager.h`

### `– downloadImageWithURL:options:completion:`

Download or retrieve from cache the image found at the url. All completions are called on an arbitrary callback queue unless called on the main thread and the result is in the memory cache (this is an optimization to allow synchronous results for the UI when an object is cached in memory).

`- (NSUUID *)downloadImageWithURL:(NSURL *)url options:(PINRemoteImageManagerDownloadOptions)options completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`url` | NSURL where the image to download resides.
`options` | PINRemoteImageManagerDownloadOptions options with which to fetch the image.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache or downloaded.

#### Return Value

An NSUUID which uniquely identifies this request. To be used for canceling requests and verifying that the callback is for the request you expect (see categories for example).

#### Declared In

`PINRemoteImageManager.h`

### `– downloadImageWithURL:options:progress:completion:`

Download or retrieve from cache the image found at the url. All completions are called on an arbitrary callback queue unless called on the main thread and the result is in the memory cache (this is an optimization to allow synchronous results for the UI when an object is cached in memory).

`- (NSUUID *)downloadImageWithURL:(NSURL *)url options:(PINRemoteImageManagerDownloadOptions)options progress:(PINRemoteImageManagerImageCompletion)progress completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`url` | NSURL where the image to download resides.
`options` | PINRemoteImageManagerDownloadOptions options with which to fetch the image.
`progress` | PINRemoteImageManagerImageCompletion block which will be called to update progress of the image download.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache or downloaded.

#### Return Value

An NSUUID which uniquely identifies this request. To be used for canceling requests and verifying that the callback is for the request you expect (see categories for example).

#### Declared In

`PINRemoteImageManager.h`

### `– downloadImageWithURL:options:processorKey:processor:completion:`

Download or retrieve from cache the image found at the url and process it before calling completion. All completions are called on an arbitrary callback queue unless called on the main thread and the result is in the memory cache (this is an optimization to allow synchronous results for the UI when an object is cached in memory).

`- (NSUUID *)downloadImageWithURL:(NSURL *)url options:(PINRemoteImageManagerDownloadOptions)options processorKey:(NSString *)processorKey processor:(PINRemoteImageManagerImageProcessor)processor completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`url` | NSURL where the image to download resides.
`options` | PINRemoteImageManagerDownloadOptions options with which to fetch the image.
`processorKey` | NSString key to uniquely identify processor and process. Will be used for caching processed images.
`processor` | PINRemoteImageManagerImageProcessor block which will be called to post-process downloaded image.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache or downloaded.

#### Return Value

An NSUUID which uniquely identifies this request. To be used for canceling requests and verifying that the callback is for the request you expect (see categories for example).

#### Declared In

`PINRemoteImageManager.h`

### `– downloadImageWithURLs:options:progress:completion:`

Download or retrieve from cache one of the images found at the urls in the passed in array based on current network performance. URLs should be sorted from lowest quality image URL to highest. All completions are called on an arbitrary callback queue unless called on the main thread and the result is in the memory cache (this is an optimization to allow synchronous results for the UI when an object is cached in memory).

`- (NSUUID *)downloadImageWithURLs:(NSArray *)urls options:(PINRemoteImageManagerDownloadOptions)options progress:(PINRemoteImageManagerImageCompletion)progress completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`urls` | An array of NSURLs of increasing size.
`options` | PINRemoteImageManagerDownloadOptions options with which to fetch the image.
`progress` | PINRemoteImageManagerImageCompletion block which will be called to update progress of the image download.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache or downloaded.

#### Return Value

An NSUUID which uniquely identifies this request. To be used for canceling requests and verifying that the callback is for the request you expect (see categories for example).

#### Declared In

`PINRemoteImageManager.h`

### `– cacheKeyForURL:processorKey:`

Returns the cacheKey for a given URL and processorKey. Exposed to be overridden if necessary or to be used with imageFromCacheWithCacheKey

`- (NSString *)cacheKeyForURL:(NSURL *)url processorKey:(NSString *)processorKey`

#### Parameters

`url` | NSURL to be downloaded
`processorKey` | NSString key to uniquely identify processor and process.

#### Return Value

returns an NSString which is the key used for caching.

#### See Also

- `

  - imageFromCacheWithCacheKey:completion:

  `

#### Declared In

`PINRemoteImageManager.h`

### `– imageFromCacheWithCacheKey:completion:`

Directly get an image from the underlying cache.

`- (void)imageFromCacheWithCacheKey:(NSString *)cacheKey completion:(PINRemoteImageManagerImageCompletion)completion`

#### Parameters

`cacheKey` | NSString key to look up image in the cache.
`completion` | PINRemoteImageManagerImageCompletion block to call when image has been fetched from the cache.

#### See Also

- `

  - cacheKeyForURL:processorKey:

  `

#### Declared In

`PINRemoteImageManager.h`

### `– cancelTaskWithUUID:`

Cancel a download. Canceling will only cancel the download if all other downloads are also canceled with their associated UUIDs. Canceling does not guarantee that your completion will not be called. You can use the UUID provided on the result object verify the completion you want called is being called.

`- (void)cancelTaskWithUUID:(NSUUID *)UUID`

#### Parameters

`UUID` | NSUUID of the task to cancel.

#### See Also

- `

  PINRemoteImageCategoryManager

  `

#### Declared In

`PINRemoteImageManager.h`

### `– setPriority:ofTaskWithUUID:`

Set the priority of a download task. Since there is only one task per download, the priority of the download task will always be the last priority this method was called with.

`- (void)setPriority:(PINRemoteImageManagerPriority)priority ofTaskWithUUID:(NSUUID *)UUID`

#### Parameters

`priority` | priority to set on the task.
`UUID` | NSUUID of the task to set the priority on.

#### Declared In

`PINRemoteImageManager.h`